<!--
  -    Copyright 2014-2023 IHE International
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<ui:composition xmlns:f="http://java.sun.com/jsf/core" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:rich="http://richfaces.org/rich" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:h="http://java.sun.com/jsf/html"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <h2>#{messages['net.ihe.gazelle.questionnaire.ATNAQuestionnaires']}</h2>
        #{dataTableStateHolder.setAscendingOn('system')}

        <h:form id="actionForm">
            <p>
                <a4j:commandLink action="/questionnaire/editor.xhtml" styleClass="gzl-btn">
                    <span class="fa fa-plus"></span>
                    <h:outputText value="#{messages['net.ihe.gazelle.questionnaire.NewATNAQuestionnaire']}"/>
                </a4j:commandLink>
                <a4j:commandLink action="/questionnaire/questionnaireTemplate.xhtml" styleClass="gzl-btn"
                                 rendered="#{s:hasRole('admin_role')}">
                    <span class="fa fa-pencil"></span>
                    <h:outputText value="#{messages['net.ihe.gazelle.questionnaire.EditATNAQuestionnaireTemplate']}"/>
                </a4j:commandLink>
            </p>
        </h:form>

        <h:form id="browserForm">

            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                           value="#{atnaQuestionnaireBrowser.filter.urlParameters}"/>
            <script>
                updateUrl("browserForm:filterUrlParameters");
                jq162("#browserForm\\:filterUrlParameters").bind('change',
                    function () {
                        updateUrl("browserForm:filterUrlParameters");
                    });
            </script>
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>

            <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                <div class="form-horizontal">
                    <div class="row">
                        <div class="col-md-6">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="form_template"
                                          value="/layout/display/_display_field_horizontal_4-8.xhtml"/>
                                <ui:param name="filter" value="#{atnaQuestionnaireBrowser.filter}"/>
                                <ui:param name="filterId" value="testingSession"/>
                                <ui:param name="filterName"
                                          value="#{messages['net.ihe.gazelle.questionnaire.TestingSession']}"/>
                                <ui:param name="filterForm" value="browserForm"/>
                            </ui:include>
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="form_template"
                                          value="/layout/display/_display_field_horizontal_4-8.xhtml"/>
                                <ui:param name="filter" value="#{atnaQuestionnaireBrowser.filter}"/>
                                <ui:param name="filterId" value="institution"/>
                                <ui:param name="filterName"
                                          value="#{messages['net.ihe.gazelle.questionnaire.Institution']}"/>
                                <ui:param name="filterForm" value="browserForm"/>
                            </ui:include>
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="form_template"
                                          value="/layout/display/_display_field_horizontal_4-8.xhtml"/>
                                <ui:param name="filter" value="#{atnaQuestionnaireBrowser.filter}"/>
                                <ui:param name="filterId" value="system"/>
                                <ui:param name="filterName"
                                          value="#{messages['net.ihe.gazelle.questionnaire.System']}"/>
                                <ui:param name="filterForm" value="browserForm"/>
                            </ui:include>
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="form_template"
                                          value="/layout/display/_display_field_horizontal_4-8.xhtml"/>
                                <ui:param name="filter" value="#{atnaQuestionnaireBrowser.filter}"/>
                                <ui:param name="filterId" value="status"/>
                                <ui:param name="filterName"
                                          value="#{messages['net.ihe.gazelle.questionnaire.Status']}"/>
                                <ui:param name="filterForm" value="browserForm"/>
                            </ui:include>
                        </div>
                        <div class="col-md-6">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="form_template"
                                          value="/layout/display/_display_field_horizontal_4-8.xhtml"/>
                                <ui:param name="filter" value="#{atnaQuestionnaireBrowser.filter}"/>
                                <ui:param name="filterId" value="creator"/>
                                <ui:param name="filterName"
                                          value="#{messages['net.ihe.gazelle.questionnaire.Creator']}"/>
                                <ui:param name="filterForm" value="browserForm"/>
                            </ui:include>
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="form_template"
                                          value="/layout/display/_display_field_horizontal_4-8.xhtml"/>
                                <ui:param name="filter" value="#{atnaQuestionnaireBrowser.filter}"/>
                                <ui:param name="filterId" value="reviewer"/>
                                <ui:param name="filterName"
                                          value="#{messages['net.ihe.gazelle.questionnaire.Reviewer']}"/>
                                <ui:param name="filterForm" value="browserForm"/>
                            </ui:include>
                            <ui:include src="/filter/filterDate.xhtml">
                                <ui:param name="form_template"
                                          value="/layout/display/_display_field_horizontal_4-8.xhtml"/>
                                <ui:param name="filter" value="#{atnaQuestionnaireBrowser.filter}"/>
                                <ui:param name="filterId" value="timestamp"/>
                                <ui:param name="filterName"
                                          value="#{messages['net.ihe.gazelle.questionnaire.LastModifiedOn']}"/>
                                <ui:param name="filterForm" value="browserForm"/>
                            </ui:include>
                        </div>
                    </div>

                </div>

                <ui:define name="filter_buttons">
                    <a4j:commandLink title="#{messages['net.ihe.gazelle.atna.ResetCriteria']}"
                                     actionListener="#{atnaQuestionnaireBrowser.reset()}"
                                     render="browserForm">
                        <span class="fa fa-times-circle"></span>
                    </a4j:commandLink>
                </ui:define>

            </ui:decorate>

            <rich:dataTable id="questionnairesTable" value="#{atnaQuestionnaireBrowser.getATNAQuestionnaires()}"
                            var="questionnaire" rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                            render="questionnaireDS">
                <g:column sortBy="#{'system'}" sortOrder="#{dataTableStateHolder.sortOrders['system']}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.questionnaire.SystemsKeyword']}</ui:define>
                    <h:outputText value="#{questionnaire.system}"/>
                </g:column>
                <g:column sortBy="#{'testingSession.description'}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.questionnaire.TestingSession']}</ui:define>
                    <h:outputText value="#{questionnaire.testingSession.description}"/>
                </g:column>
                <g:column>
                    <ui:define name="header">#{messages['net.ihe.gazelle.questionnaire.Status']}</ui:define>
                    <h:outputText value="#{questionnaire.status.value}"/>
                </g:column>
                <g:column sortBy="#{'owner'}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.questionnaire.Owner']}</ui:define>
                    <h:outputText value="#{atnaQuestionnaireBrowser.getUserName(questionnaire.getUsernameWithKey())}"/>
                </g:column>
                <g:column sortBy="#{'lastModifier'}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.questionnaire.LastModifier']}</ui:define>
                    <h:outputText value="#{atnaQuestionnaireBrowser.getUserName(questionnaire.getLastModifierWithKey())}"/>
                </g:column>
                <g:column sortBy="#{'lastModifiedDate'}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.questionnaire.LastModifiedOn']}</ui:define>
                    <g:date value="#{questionnaire.lastModifiedDate}"/>
                </g:column>
                <g:column>
                    <ui:define name="header">#{messages['net.ihe.gazelle.questionnaire.Action']}</ui:define>
                    <div class="gzl-never-wrap">
                        <h:commandLink action="#{atnaQuestionnaireBrowser.showQuestionnaire(questionnaire)}"
                                       title="#{messages['net.ihe.gazelle.questionnaire.ShowQuestionnaire']}">
                            <span class="fa fa-search"></span>
                        </h:commandLink>
                        <h:commandLink action="#{atnaQuestionnaireBrowser.proofreadQuestionnaire(questionnaire)}"
                                       rendered="#{s:hasRole('monitor_role')}"
                                       title="#{messages['net.ihe.gazelle.questionnaire.ProofreadQuestionnaire']}">
                        <span class="gzl-icon-stack">
                            <i class="fa fa-file-o gzl-icon-stack-1x"></i>
                            <i class="gzl-icon-checked gzl-icon-stack-1x gzl-icon-stack-right"></i>
                        </span>
                        </h:commandLink>
                        <h:commandLink action="#{atnaQuestionnaireBrowser.editQuestionnaire(questionnaire)}"
                                       rendered="#{not (s:hasRole('monitor_role') and not s:hasRole('admin_role'))}"
                                       title="#{messages['net.ihe.gazelle.questionnaire.EditQuestionnaire']}">
                            <span class="fa fa-pencil"></span>
                        </h:commandLink>
                        <a4j:commandLink
                                action="#{atnaQuestionnaireBrowser.setSelectedQuestionnnaireId(questionnaire.id)}"
                                rendered="#{atnaQuestionnaireAccessControl.isUserAllowedToDelete(questionnaire.id)}"
                                styleClass="text-danger"
                                title="#{messages['net.ihe.gazelle.questionnaire.DeleteATNAQuestionnaire']}"
                                render=" :deleteText"
                                oncomplete="jq162('#deleteModal').modal('show');">
                            <span class="fa fa-trash-o text-danger"></span>
                        </a4j:commandLink>
                    </div>
                </g:column>

                <f:facet name="footer">
                    <ui:include src="/util/datatableFooter.xhtml">
                        <ui:param name="dataScrollerId" value="questionnaireDS"/>
                        <ui:param name="dataTableId" value="questionnairesTable"/>
                    </ui:include>
                </f:facet>
            </rich:dataTable>

        </h:form>


        <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
            <ui:param name="popup_id" value="deleteModal"/>
            <ui:define name="popup_title"><span class="fa fa-exclamation-triangle"></span>#{messages['net.ihe.gazelle.questionnaire.Warning']}
            </ui:define>
            <s:div id="deleteText">
                <p>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.questionnaire.YouAreAboutToDeleteTheATNAQuestionnaireForTheSys']} #{atnaQuestionnaireBrowser.getSelectedQuestionnaireSystem()}. #{messages['net.ihe.gazelle.questionnaire.ThisCanNotBeUndone']}"/>
                </p>
            </s:div>
            <ui:define name="popup_footer">
                <h:form id="deleteForm">
                    <!--<s:token allowMultiplePosts="true"/>-->
                    <h:commandButton action="#{atnaQuestionnaireBrowser.setSelectedQuestionnnaireId(0)}"
                                     oncomplete="jq162('#deleteModal').modal('hide');"
                                     value="#{messages['net.ihe.gazelle.atna.Cancel']}"
                                     styleClass="gzl-btn"/>
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.atna.Delete']}"
                                       action="#{atnaQuestionnaireBrowser.deleteQuestionnaire(atnaQuestionnaireBrowser.getSelectedQuestionnnaireId())}"
                                       oncomplete="jq162('#deleteModal').modal('hide')"
                                       render="gazelle-messages,browserForm"
                                       styleClass="gzl-btn-red"/>
                </h:form>
            </ui:define>
        </ui:decorate>

    </ui:define>
</ui:composition>
